<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (17)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="loops-while-and-for">Loops: while and for</h1>
    <p>We often need to repeat actions.</p>
    <p>
      For example, outputting goods from a list one after another or just
      running the same code for each number from 1 to 10.
    </p>
    <p><em>Loops</em> are a way to repeat the same code multiple times.</p>
    <h2 id="the-while-loop">The “while” loop</h2>
    <p>The <code>while</code> loop has the following syntax:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="cf">while</span> (condition) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="co">// code</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="co">// so-called &quot;loop body&quot;</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      While the <code>condition</code> is truthy, the <code>code</code> from the
      loop body is executed.
    </p>
    <p>
      For instance, the loop below outputs <code>i</code> while
      <code>i &lt; 3</code>:
    </p>
    <p>
      <code
        >js run let i = 0; while (i &lt; 3) { // shows 0, then 1, then 2
        alert(i); i++; }</code
      >
    </p>
    <p>
      A single execution of the loop body is called <em>an iteration</em>. The
      loop in the example above makes three iterations.
    </p>
    <p>
      If <code>i++</code> was missing from the example above, the loop would
      repeat (in theory) forever. In practice, the browser provides ways to stop
      such loops, and in server-side JavaScript, we can kill the process.
    </p>
    <p>
      Any expression or variable can be a loop condition, not just comparisons:
      the condition is evaluated and converted to a boolean by
      <code>while</code>.
    </p>
    <p>
      For instance, a shorter way to write <code>while (i != 0)</code> is
      <code>while (i)</code>:
    </p>
    <p>
      <code
        >js run let i = 3; *!* while (i) { // when i becomes 0, the condition
        becomes falsy, and the loop stops */!* alert( i ); i--; }</code
      >
    </p>
    <p>
      ```<code
        >smart header="Curly braces are not required for a single-line body" If
        the loop body has a single statement, we can omit the curly braces</code
      >{…}`:
    </p>
    <p><code>js run let i = 3; *!* while (i) alert(i--); */!*</code> ````</p>
    <h2 id="the-do..while-loop">The “do..while” loop</h2>
    <p>
      The condition check can be moved <em>below</em> the loop body using the
      <code>do..while</code> syntax:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="cf">do</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="co">// loop body</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="op">}</span> <span class="cf">while</span> (condition)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      The loop will first execute the body, then check the condition, and, while
      it’s truthy, execute it again and again.
    </p>
    <p>For example:</p>
    <p>
      <code>js run let i = 0; do { alert(i); i++; } while (i &lt; 3);</code>
    </p>
    <p>
      This form of syntax should only be used when you want the body of the loop
      to execute <strong>at least once</strong> regardless of the condition
      being truthy. Usually, the other form is preferred:
      <code>while(…) {…}</code>.
    </p>
    <h2 id="the-for-loop">The “for” loop</h2>
    <p>
      The <code>for</code> loop is more complex, but it’s also the most commonly
      used loop.
    </p>
    <p>It looks like this:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="cf">for</span> (begin<span class="op">;</span> condition<span class="op">;</span> step) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="co">// ... loop body ...</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Let’s learn the meaning of these parts by example. The loop below runs
      <code>alert(i)</code> for <code>i</code> from <code>0</code> up to (but
      not including) <code>3</code>:
    </p>
    <p>
      <code
        >js run for (let i = 0; i &lt; 3; i++) { // shows 0, then 1, then 2
        alert(i); }</code
      >
    </p>
    <p>Let’s examine the <code>for</code> statement part-by-part:</p>
    <table>
      <colgroup>
        <col style="width: 11%" />
        <col style="width: 12%" />
        <col style="width: 76%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>part</th>
          <th></th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>begin</td>
          <td><code>i = 0</code></td>
          <td>Executes once upon entering the loop.</td>
        </tr>
        <tr class="even">
          <td>condition</td>
          <td><code>i &lt; 3</code></td>
          <td>
            Checked before every loop iteration. If false, the loop stops.
          </td>
        </tr>
        <tr class="odd">
          <td>body</td>
          <td><code>alert(i)</code></td>
          <td>Runs again and again while the condition is truthy.</td>
        </tr>
        <tr class="even">
          <td>step</td>
          <td><code>i++</code></td>
          <td>Executes after the body on each iteration.</td>
        </tr>
      </tbody>
    </table>
    <p>The general loop algorithm works like this:</p>
    <pre><code>Run begin
→ (if condition → run body and run step)
→ (if condition → run body and run step)
→ (if condition → run body and run step)
→ ...</code></pre>
    <p>
      That is, <code>begin</code> executes once, and then it iterates: after
      each <code>condition</code> test, <code>body</code> and
      <code>step</code> are executed.
    </p>
    <p>
      If you are new to loops, it could help to go back to the example and
      reproduce how it runs step-by-step on a piece of paper.
    </p>
    <p>Here’s exactly what happens in our case:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="co">// for (let i = 0; i &lt; 3; i++) alert(i)</span></a>
<a class="sourceLine" id="cb5-2" title="2"></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="co">// run begin</span></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="co">// if condition → run body and run step</span></a>
<a class="sourceLine" id="cb5-6" title="6"><span class="cf">if</span> (i <span class="op">&lt;</span> <span class="dv">3</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="at">alert</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-8" title="8">  i<span class="op">++;</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-10" title="10"><span class="co">// if condition → run body and run step</span></a>
<a class="sourceLine" id="cb5-11" title="11"><span class="cf">if</span> (i <span class="op">&lt;</span> <span class="dv">3</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-12" title="12">  <span class="at">alert</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-13" title="13">  i<span class="op">++;</span></a>
<a class="sourceLine" id="cb5-14" title="14"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-15" title="15"><span class="co">// if condition → run body and run step</span></a>
<a class="sourceLine" id="cb5-16" title="16"><span class="cf">if</span> (i <span class="op">&lt;</span> <span class="dv">3</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-17" title="17">  <span class="at">alert</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-18" title="18">  i<span class="op">++;</span></a>
<a class="sourceLine" id="cb5-19" title="19"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-20" title="20"><span class="co">// ...finish, because now i == 3</span></a></code></pre>
    </div>
    <p>
      ```<code
        >smart header="Inline variable declaration" Here, the "counter"
        variable</code
      >i` is declared right in the loop. This is called an “inline” variable
      declaration. Such variables are visible only inside the loop.
    </p>
    <p>
      <code
        >js run for (*!*let*/!* i = 0; i &lt; 3; i++) { alert(i); // 0, 1, 2 }
        alert(i); // error, no such variable</code
      >
    </p>
    <p>Instead of defining a variable, we could use an existing one:</p>
    <p>```js run let i = 0;</p>
    <p>
      for (i = 0; i &lt; 3; i++) { // use an existing variable alert(i); // 0,
      1, 2 }
    </p>
    <p>alert(i); // 3, visible, because declared outside of the loop</p>
    <pre><code></code></pre>
    <h3 id="skipping-parts">Skipping parts</h3>
    <p>Any part of <code>for</code> can be skipped.</p>
    <p>
      For example, we can omit <code>begin</code> if we don’t need to do
      anything at the loop start.
    </p>
    <p>Like here:</p>
    <p>```js run let i = 0; // we have i already declared and assigned</p>
    <p>
      for (; i &lt; 3; i++) { // no need for “begin” alert(i); // 0, 1, 2 } ```
    </p>
    <p>We can also remove the <code>step</code> part:</p>
    <p>```js run let i = 0;</p>
    <p>for (; i &lt; 3; ) { alert(i++); } ```</p>
    <p>This makes the loop identical to <code>while (i &lt; 3)</code>.</p>
    <p>We can actually remove everything, creating an infinite loop:</p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="cf">for</span> (<span class="op">;;</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="co">// repeats without limits</span></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Please note that the two <code>for</code> semicolons <code>;</code> must
      be present. Otherwise, there would be a syntax error.
    </p>
    <h2 id="breaking-the-loop">Breaking the loop</h2>
    <p>Normally, a loop exits when its condition becomes falsy.</p>
    <p>
      But we can force the exit at any time using the special
      <code>break</code> directive.
    </p>
    <p>
      For example, the loop below asks the user for a series of numbers,
      “breaking” when no number is entered:
    </p>
    <p>```js run let sum = 0;</p>
    <p>while (true) {</p>
    <p>let value = +prompt(“Enter a number”, ’’);</p>
    <p><em>!</em> if (!value) break; // (<em>) </em>/!*</p>
    <p>sum += value;</p>
    <p>} alert( ‘Sum:’ + sum ); ```</p>
    <p>
      The <code>break</code> directive is activated at the line
      <code>(*)</code> if the user enters an empty line or cancels the input. It
      stops the loop immediately, passing control to the first line after the
      loop. Namely, <code>alert</code>.
    </p>
    <p>
      The combination “infinite loop + <code>break</code> as needed” is great
      for situations when a loop’s condition must be checked not in the
      beginning or end of the loop, but in the middle or even in several places
      of its body.
    </p>
    <h2 id="continue-to-the-next-iteration-continue">
      Continue to the next iteration [#continue]
    </h2>
    <p>
      The <code>continue</code> directive is a “lighter version” of
      <code>break</code>. It doesn’t stop the whole loop. Instead, it stops the
      current iteration and forces the loop to start a new one (if the condition
      allows).
    </p>
    <p>
      We can use it if we’re done with the current iteration and would like to
      move on to the next one.
    </p>
    <p>The loop below uses <code>continue</code> to output only odd values:</p>
    <p>```js run no-beautify for (let i = 0; i &lt; 10; i++) {</p>
    <p>
      // if true, skip the remaining part of the body <em>!</em>if (i % 2 == 0)
      continue;<em>/!</em>
    </p>
    <p>alert(i); // 1, then 3, 5, 7, 9 } ```</p>
    <p>
      For even values of <code>i</code>, the <code>continue</code> directive
      stops executing the body and passes control to the next iteration of
      <code>for</code> (with the next number). So the <code>alert</code> is only
      called for odd values.
    </p>
    <p>
      ```<code>smart header="The</code>continue` directive helps decrease
      nesting" A loop that shows odd values could look like this:
    </p>
    <p>
      <code
        >js run for (let i = 0; i &lt; 10; i++) { if (i % 2) { alert(i); }
        }</code
      >
    </p>
    <p>
      From a technical point of view, this is identical to the example above.
      Surely, we can just wrap the code in an <code>if</code> block instead of
      using <code>continue</code>.
    </p>
    <p>
      But as a side-effect, this created one more level of nesting (the
      <code>alert</code> call inside the curly braces). If the code inside of
      <code>if</code> is longer than a few lines, that may decrease the overall
      readability.
    </p>
    <pre><code>
````warn header=&quot;No `break/continue` to the right side of &#39;?&#39;&quot;
Please note that syntax constructs that are not expressions cannot be used with the ternary operator `?`. In particular, directives such as `break/continue` aren&#39;t allowed there.

For example, if we take this code:

```js
if (i &gt; 5) {
  alert(i);
} else {
  continue;
}
```

...and rewrite it using a question mark:


```js no-beautify
(i &gt; 5) ? alert(i) : *!*continue*/!*; // continue isn&#39;t allowed here
```

...it stops working: there&#39;s a syntax error.

This is just another reason not to use the question mark operator `?` instead of `if`.</code></pre>
    <h2 id="labels-for-breakcontinue">Labels for break/continue</h2>
    <p>Sometimes we need to break out from multiple nested loops at once.</p>
    <p>
      For example, in the code below we loop over <code>i</code> and
      <code>j</code>, prompting for the coordinates <code>(i, j)</code> from
      <code>(0,0)</code> to <code>(2,2)</code>:
    </p>
    <p>
      ``<code
        >js run no-beautify for (let i = 0; i &lt; 3; i++) { for (let j = 0; j
        &lt; 3; j++) { let input = prompt(</code
      >Value at coords (<span class="math inline"><em>i</em>,</span>{j})`, "");
    </p>
    <pre><code>// what if we want to exit from here to Done (below)?</code></pre>
    <p>} }</p>
    <p>alert(“Done!”); ```</p>
    <p>We need a way to stop the process if the user cancels the input.</p>
    <p>
      The ordinary <code>break</code> after <code>input</code> would only break
      the inner loop. That’s not sufficient – labels, come to the rescue!
    </p>
    <p>A <em>label</em> is an identifier with a colon before a loop:</p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1">labelName<span class="op">:</span> <span class="cf">for</span> (...) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  ...</a>
<a class="sourceLine" id="cb10-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      The <code>break &lt;labelName&gt;</code> statement in the loop below
      breaks out to the label:
    </p>
    <p>
      ```js run no-beautify <em>!</em>outer:<em>/!</em> for (let i = 0; i &lt;
      3; i++) {
    </p>
    <p>for (let j = 0; j &lt; 3; j++) {</p>
    <pre><code>let input = prompt(`Value at coords (${i},${j})`, &#39;&#39;);

// if an empty string or canceled, then break out of both loops
if (!input) *!*break outer*/!*; // (*)

// do something with the value...</code></pre>
    <p>} } alert(‘Done!’); ```</p>
    <p>
      In the code above, <code>break outer</code> looks upwards for the label
      named <code>outer</code> and breaks out of that loop.
    </p>
    <p>
      So the control goes straight from <code>(*)</code> to
      <code>alert('Done!')</code>.
    </p>
    <p>We can also move the label onto a separate line:</p>
    <p>
      <code>js no-beautify outer: for (let i = 0; i &lt; 3; i++) { ... }</code>
    </p>
    <p>
      The <code>continue</code> directive can also be used with a label. In this
      case, code execution jumps to the next iteration of the labeled loop.
    </p>
    <p>
      ````warn header=“Labels do not allow to”jump" anywhere" Labels do not
      allow us to jump into an arbitrary place in the code.
    </p>
    <p>For example, it is impossible to do this:</p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="cf">break</span> label<span class="op">;</span> <span class="co">// jump to the label below (doesn&#39;t work)</span></a>
<a class="sourceLine" id="cb12-2" title="2"></a>
<a class="sourceLine" id="cb12-3" title="3">label<span class="op">:</span> <span class="cf">for</span> (...)</a></code></pre>
    </div>
    <p>
      A <code>break</code> directive must be inside a code block. Technically,
      any labelled code block will do, e.g.:
    </p>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1">label<span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-2" title="2">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb13-3" title="3">  <span class="cf">break</span> label<span class="op">;</span> <span class="co">// works</span></a>
<a class="sourceLine" id="cb13-4" title="4">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb13-5" title="5"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      …Although, 99.9% of the time <code>break</code> used is inside loops, as
      we’ve seen in the examples above.
    </p>
    <p>A <code>continue</code> is only possible from inside a loop. ````</p>
    <h2 id="summary">Summary</h2>
    <p>We covered 3 types of loops:</p>
    <ul>
      <li>
        <code>while</code> – The condition is checked before each iteration.
      </li>
      <li>
        <code>do..while</code> – The condition is checked after each iteration.
      </li>
      <li>
        <code>for (;;)</code> – The condition is checked before each iteration,
        additional settings available.
      </li>
    </ul>
    <p>
      To make an “infinite” loop, usually the <code>while(true)</code> construct
      is used. Such a loop, just like any other, can be stopped with the
      <code>break</code> directive.
    </p>
    <p>
      If we don’t want to do anything in the current iteration and would like to
      forward to the next one, we can use the <code>continue</code> directive.
    </p>
    <p>
      <code>break/continue</code> support labels before the loop. A label is the
      only way for <code>break/continue</code> to escape a nested loop to go to
      an outer one.
    </p>
  </body>
</html>
